* PART 2


import delimited "Consumption_monthly_twitter_chart.csv", encoding(ISO-8859-2) clear

gen M = substr(date, 1, strpos(date, "/")-1 )
gen year = substr(date,-4,.)
destring M year, replace
gen edate = mdy(M,1,year)
gen month = mofd(edate)
drop M edate
format month %tm

gen goodshare = 100*(1 - csbm/cbm)
tsset month

label var goodshare "Goods Share, Percent"
label var dspi "Disposable Personal Income (bn)"


twoway ///
(tsline goodshare if tin(2019m1,2022m12), ///
ysc(r(30 37)) lcolor(red) lwidth(.5) ytitle("") ///
ylabel(30(1)37, labcolor(red) angle(horizontal))) ///
///
(tsline dspi if tin(2019m1,2022m12), lcolor(blue) yaxis(2) lwidth(.3) xtitle("") ///
ytitle("", axis(2)) ///
ylabel(, axis(2) labcolor(blue) angle(horizontal))), ///
legend(size(*.8) ring(0) position(11) rows(2) symysize(*0.01) symxsize(*0.4)) ///
///
name(rameyall, replace) graphregion(fcolor(white)) 
